#include "resrc1.h"
#include "MATH.H"

LRESULT CALLBACK ParamDlgProc(HWND hdlg,UINT uMessage,WPARAM wparam,LPARAM lparam);
void Param2Dlg();
void Dlg2Param();
void ZerroTruncate(char *str);
void GetHandles();
void EnableAll();
HWND ParamHWND;
HWND L_hwnd,M_hwnd,J_hwnd,X_hwnd,Y_hwnd;
int FirstStart=1;
int NoShow=-1;

#pragma argsused
LRESULT CALLBACK ParamDlgProc(HWND hdlg,UINT uMessage,WPARAM wparam,LPARAM lparam)
{
  WORD Command;

  switch (uMessage)
  {
    case WM_INITDIALOG:
      SetWindowPos(hdlg,NULL, WinSizeX,0, 0,0, SWP_NOSIZE | SWP_NOZORDER);
      EnableWindow(MainWin,1);
      ParamHWND=hdlg;
      GetHandles();
      Param2Dlg();
      break;
    case WM_COMMAND:
      Command=LOWORD(wparam);
      if(Command==IDOK)
        Dlg2Param();
      if(Command==IDCANCEL)
        break;
      break;
    case WM_CLOSE:
      NoShow=Select;
      ShowWindow(ParamHWND,SW_HIDE);
      break;

    case WM_PAINT:
      if(FirstStart==1)
      {
        FirstStart=0;
        ShowWindow(ParamHWND,SW_HIDE);
      }
      break;
    default:
      return 0;
//      return DefDlgProc(hdlg, uMessage, wparam, lparam);
  }
  return 0;
}

void GetHandles()
{
  L_hwnd=GetDlgItem(ParamHWND,IDC_EDIT_L);
  M_hwnd=GetDlgItem(ParamHWND,IDC_EDIT_M);
  J_hwnd=GetDlgItem(ParamHWND,IDC_EDIT_J);
  X_hwnd=GetDlgItem(ParamHWND,IDC_EDIT_X);
  Y_hwnd=GetDlgItem(ParamHWND,IDC_EDIT_Y);
}

void EnableAll()
{
  EnableWindow(L_hwnd,1);
  EnableWindow(M_hwnd,1);
  EnableWindow(J_hwnd,1);
  EnableWindow(X_hwnd,1);
  EnableWindow(Y_hwnd,1);
}

void ZerroTruncate(char *str)
{
  int i,j;

  for(i=0;str[i]!=0 && str[i]!='.';++i);
  if(str[i]=='.')
  {
    for(j=i;str[j]!=0;++j);
    for(--j;str[j]=='0';--j)
      str[j]=0;
    if(str[j]=='.')
      str[j]=0;
  }
}

void Param2Dlg()
{
  int i;
  char szbuf[100];
  double x,y;

  EnableAll();
  if(Select==0 || NoShow==Select)
    ShowWindow(ParamHWND,SW_HIDE);
  else
  {
    NoShow=-1;
    ShowWindow(ParamHWND,SW_SHOW);
    SetFocus(MainWin);
  }
  if(Select==7 || Select==8 || Select==9)
  {
    if(Select!=7)
      EnableWindow(M_hwnd,0);
    if(Select!=9)
      EnableWindow(J_hwnd,0);
    EnableWindow(L_hwnd,0);
  }
  if(Select==8)
    SetDlgItemText(ParamHWND,IDC_KOORD,"");
  if(Select==9)
    SetDlgItemText(ParamHWND,IDC_TEXT_J,":");
  else
    SetDlgItemText(ParamHWND,IDC_TEXT_J," :");
  if(Select==8)
  {
    sprintf(szbuf,"O1");
    SetWindowText(ParamHWND,szbuf);
  }
  if(Select==9)
  {
    sprintf(szbuf,"");
    SetWindowText(ParamHWND,szbuf);
  }
  if(Select>0 && Select<8)
  {
    i=Select;
    if(i==4 || i==5)
      i=2;
    else
      if(i>5)
        i-=2;
    sprintf(szbuf," %i",i);
    SetWindowText(ParamHWND,szbuf);
    SetDlgItemText(ParamHWND,IDC_KOORD,"  ");
  }
  sprintf(szbuf,"%.10lf",L[Select]);
  ZerroTruncate(szbuf);
  SetDlgItemText(ParamHWND,IDC_EDIT_L,szbuf);
  if(Select!=9)
    sprintf(szbuf,"%.10lf",J[Select]);
  else
    sprintf(szbuf,"%.10lf",beta/M_PI*180);
  ZerroTruncate(szbuf);
  SetDlgItemText(ParamHWND,IDC_EDIT_J,szbuf);

  i=Select;
  if(i==4 || i==5)
    i=2;
  if(i==6 || i==7)
    i-=2;
  sprintf(szbuf,"%.10lf",M[i]);
  ZerroTruncate(szbuf);
  SetDlgItemText(ParamHWND,IDC_EDIT_M,szbuf);
  if(Select>0 && Select<8)
  {
    i=Select;
    if(i==4 || i==5)
      i=2;
    if(i==6 || i==7)
      i-=2;
    x=MC[i].x;
    y=MC[i].y;
  }
  if(Select==8)
  {
    x=o1.x;
    y=o1.y;
  }
  if(Select==9)
  {
    x=mm.x;
    y=mm.y;
  }
  sprintf(szbuf,"%.10lf",x);
  ZerroTruncate(szbuf);
  SetDlgItemText(ParamHWND,IDC_EDIT_X,szbuf);
  sprintf(szbuf,"%.10lf",y);
  ZerroTruncate(szbuf);
  SetDlgItemText(ParamHWND,IDC_EDIT_Y,szbuf);
}

void Dlg2Param()
{
  char szbuf[100];
  double x,y;
  int i;

  StatusSaved=1;
  SaveStat();
  GetDlgItemText(ParamHWND, IDC_EDIT_L, szbuf, 100);
  L[Select] = atof(szbuf);
  GetDlgItemText(ParamHWND, IDC_EDIT_M, szbuf, 100);
  i=Select;
  if(i==4 || i==5)
    i=2;
  if(i==6 || i==7)
    i-=2;
  M[i] = atof(szbuf);
  GetDlgItemText(ParamHWND, IDC_EDIT_J, szbuf, 100);
  if(Select!=9)
    J[Select] = atof(szbuf);
//  else
//    beta=atof(szbuf)*M_PI/180;
  GetDlgItemText(ParamHWND, IDC_EDIT_X, szbuf, 100);
  x = atof(szbuf);
  GetDlgItemText(ParamHWND, IDC_EDIT_Y, szbuf, 100);
  y = atof(szbuf);
  if(Select<8)
  {
    i=Select;
    if(i==4 || i==5)
      i=2;
    if(i==6 || i==7)
      i-=2;
    MC[i].x=x;
    MC[i].y=y;
    MC_changed=1;
  }
  if(Select==8)
  {
    o1.x=x;
    o1.y=y;
  }
  if(Select==9)
  {
    mm.x=x;
    mm.y=y;
  }

  RedrawWindow(MainWin,NULL,NULL,/*RDW_ERASE |*/ RDW_INVALIDATE | RDW_UPDATENOW);
}

